<?
/**
	To do:
	- readIniKey method
	- think of something to replace findObjFromHandler method
	      (what about making the $w global var, use IDS as indexes?)
**/

class Wb{
	static $winbinder_ver = "0.25";
	static $oo_ver        = "0.1";

	static Function getFolderFiles($path, $subdirs=false, $fullname=true, $mask=""){
		return get_folder_files($path, $subdirs, $fullname);
	}
	static Function parseRc($rctext, $winvar=false, $parent=false, $type=false, $caption=false, $xpos=false, $ypos=false, $width=false, $height=false, $style=false, $lparam=false){
		$tmp = parse_rc($rctext, $winvar, $parent, $type, $caption, $xpos, $ypos, $width, $height, $style, $lparam);
		$parent = $parent?$parent:"NULL";

		if(ereg("Window", $type)){
			preg_match("/\\$winvar = wb_create_window\($parent, (.*?), (.*), (.*?), (.*?), (.*?), (.*?), (.*?), (.*?)\)/", $tmp, $output);
			$torep = "$winvar"."[\"main\"] = new Wb$type($output[2], $output[3], $output[4], $output[5], $output[6], $output[7], $output[8])";
		}
		else{
			preg_match("/\\$winvar = wb_create_window\((.*?), (.*?), (.*), (.*?), (.*?), (.*?), (.*?), (.*?), (.*?)\)/", $tmp, $output);
			$torep = "$winvar"."[\"main\"] = new Wb$type($output[1], $output[3], $output[4], $output[5], $output[6], $output[7], $output[8], $output[9])";
		}
		$tmp = str_replace($output[0], $torep, $tmp);
//		echo "From: $output[0]\r\n";
//		echo "To:   $torep\r\n";

		preg_match_all("/wb_create_control\((.*?), (.*?), (.*), (.*?), (.*?), (.*?), (.*?), (.*?), (.*?)\)/", $tmp, $output);
		for($x = 0; $x < sizeof($output[0]); $x++){
			$class = $output[2][$x];
			$caption=$output[3][$x];
			$xpos  = $output[4][$x];
			$ypos  = $output[5][$x];
			$width = $output[6][$x];
			$height= $output[7][$x];
			$id    = $output[8][$x];
			$style = $output[9][$x];
			$lparam= "NULL";
			switch($class){
				// Without 'xy' and 'wh' properties
				case "Accel":
					$parms = "$winvar"."[$id] = new Wb$class($winvar"."[\"main\"], $caption, $id, $lparam)";
					break;

				case "Menu":
				case "StatusBar":
					$parms = "$winvar"."[$id] = new Wb$class($winvar"."[\"main\"], $caption, $id, $style, $lparam)";
					break;

				case "ToolBar":
					$parms = "$winvar"."[$id] = new Wb$class($winvar"."[\"main\"], $caption, $width, $height, $caption)";
					break;

				// Without 'caption'
				case "Frame":
				case "Gauge":
				case "ScrollBar":
				case "Slider":
				case "TabControl":
				case "WbTreeView":
					$parms = "$winvar"."[$id] = new Wb$class($winvar"."[\"main\"], $xpos, $ypos, $width, $height, $id, $style, $lparam)";
					break;

				// All the parameters:
				default:
					$parms = "$winvar"."[$id] = new Wb$class($winvar"."[\"main\"], $xpos, $ypos, $width, $height, $caption, $id, $style, $lparam)";
			}
			$tmp = str_replace($output[0][$x], $parms, $tmp);
		}
		return $tmp;
	}
	static Function exec($command, $param=false){
		return wb_exec($command, $param);
	}
	static Function findFile($filename){
		return wb_find_file($filename);
	}
	static Function getSystemInfo($info){
		/**
			The following 'infos' are supported:
				"apppath", "fontpath", "gdiobjects", "instance", "ospath",
				"osversion", "osversionnumber", "systempath", userobjects"
		**/
		return wb_get_system_info($info);
	}
	static Function mainLoop(){
		return wb_main_loop();
	}
	static Function playSound($style){
		/**
			The following styles are supported:
				WBC_OK, WBC_INFO, WBC_WARNING
				WBC_STOP, WBC_QUESTION, WBC_BEEP
		**/
		return wb_play_sound($style);
	}
	static Function readIniKey(){
		// Not working at all, will change.
		/** to do **/
	}

	/**
		Below this point, are listed the "Low-level Functions"
		Warning: these are low-level functions and should be
		         used only for hacking and debugging.
	**/
	static Function getAddress($string){
		return wb_get_address($string);
	}
	static Function peek($address, $length=false){
		return wb_peek($address, $length);
	}
	static Function poke($address, $contents, $length=false){
		return wb_poke($address, $contents, $length);
	}
	static Function sendMessage(wbObject $object, $message, $wparam, $lparam){
		return wb_send_message($object->handler, $message, $wparam, $lparam);
	}
	static Function setStyle(wbObject $object, $style){
		return wb_set_style($object->handler, $style);
	}
	static Function getPixel($source, $posx, $posy){
		return wb_get_pixel($source,$posx, $posy);
	}
	static Function setPixel($source, $posx, $posy, $color){
		return wb_set_pixel($source,$posx, $posy, $color);
	}

	/**
		Additional functions, to make coding easier
	**/
	static Function importRc($rcfile, $winvar=false, $parent=false, $type=false, $caption=false, $xpos=false, $ypos=false, $width=false, $height=false, $style=false, $lparam=false){
		if(!$style)
			$style = "NULL";
		$toeval = self::parseRc(file_get_contents($rcfile), $winvar, $parent, $type, $caption, $xpos, $ypos, $width, $height, $style, $lparam);
		// file_put_contents("a.php", $toeval); // for debugging purposes
		return $toeval;
	}

	/**
		The following method is a 'trick', and its use is not recommended
		'objlist' should be an Array, containing all the searchable controls
	**/
	static Function findObjFromHandler($handler, &$objlist){
		foreach($objlist as $index=>$object){
			if($object->handler == $handler)
				return $object;
		}
	}
}
