<?
abstract class WbControl extends WbObject{
	// Virtual attributes:
	//   disabled, value
	public Function __construct($parent, $type, $caption=false, $posx=false, $posy=false, $width=false, $height=false, $id=false, $style=false, $lparam=false){
		$this->handler = wb_create_control($parent->handler, $type, $caption, $posx, $posy, $width, $height, $id, $style, $lparam);
	}
	public Function __get($var){
		switch($var){
			case "disabled":  return !$this->getEnabled();
			case "value":     return $this->getValue();
		}
		return parent::__get($var);
	}
	public Function __set($var, $value){
		switch($var){
			case "disabled":  return $this->setEnabled(!$value);
			case "value":     return $this->setValue($value);
		}
		return parent::__set($var, $value);
	}
	
	public Function getEnabled(){
		return wb_get_enabled($this->handler);
	}
	public Function setEnabled($enabled){
		return wb_set_enabled($this->handler, $enabled);
	}
	public Function getValue(){
		return wb_get_value($this->handler);
	}
	public Function setValue($value){
		return wb_set_value($this->handler, $value);
	}
}

require "ooi_wbcontrols/wbaccel.php"; // to do
require "ooi_wbcontrols/wbcalendar.php"; // missing
require "ooi_wbcontrols/wbcheckbox.php"; // done [changes]
require "ooi_wbcontrols/wbcombobox.php"; // done [changes]
require "ooi_wbcontrols/wbeditbox.php"; // done
require "ooi_wbcontrols/wbframe.php"; // done [changes]
require "ooi_wbcontrols/wbgauge.php"; // done [changes]
require "ooi_wbcontrols/wbgroupbox.php"; // done
require "ooi_wbcontrols/wbhtmleditbox.php"; // missing
require "ooi_wbcontrols/wblabel.php"; // done
require "ooi_wbcontrols/wblistbox.php"; // done [=combobox]
require "ooi_wbcontrols/wbmenu.php"; // done, but I think there are more things to do in here
require "ooi_wbcontrols/wbpicture.php"; // done [changes]
require "ooi_wbcontrols/wbpushbutton.php"; // done
require "ooi_wbcontrols/wbradiobutton.php"; // done [=checkbox], but i believe it's incomplete
require "ooi_wbcontrols/wbrtfeditbox.php"; // done [changes]
require "ooi_wbcontrols/wbscrollbar.php"; // done [changes]
require "ooi_wbcontrols/wbslider.php"; // done [changes]
require "ooi_wbcontrols/wbspinner.php"; // missing
require "ooi_wbcontrols/wbstatusbar.php"; // done [changes]
require "ooi_wbcontrols/wbtabcontrol.php"; // done [changes]
require "ooi_wbcontrols/wbtoolbar.php"; // done [changes]