<?
abstract class WbObject{
	public $handler;
	// Virtual attributes:
	//   class, text, visible
	public Function __get($var){
		switch($var){
			case "class":   return $this->getClass();
			case "text":    return $this->getText();
			case "visible": return $this->getVisible();
		}
		return null;
	}
	
	public Function __set($var, $val){
		switch($var){
			case "text":    return $this->setText($val);
			case "visible": return $this->setVisible($val);
		}
		return null;
	}
	
	/**
		Class methods
	**/	
	public Function getClass(){
		return wb_get_class($this->handler);
	}
	public Function getText($item=false, $subitem=false){
		return wb_get_text($this->handler, $item, $subitem);
	}
	public Function getVisible(){
		return wb_get_visible($this->handler);
	}
	public Function refresh($now=true){
		return wb_refresh ($this->handler, $now);
	}
	public Function sendMessage($message, $wparam, $lparam){
		return wb_send_message($this->handler, $message, $wparam, $lparam);
	}
	public Function setFocus(){
		return wb_set_focus($this->handler);
	}
	public Function setImage($source, $index=false, $transparentColor=false, $lparam=false){
		/**
			Can be called in two different ways:
				setImage(WbImage $source);
				setImage(string  $source, $index=false, $transparentcolor=false, $lparam=false)
		**/
		return (!is_string($source))?
			wb_set_image($this->handler, $source->handler):
			wb_set_image($this->handler, $source, $index, $transparentColor, $lparam);
	}
	public Function setPosition($posx, $posy){
		return wb_set_position($this->handler, $posx, $poxy);
	}
	public Function setSize($width, $height){
		return wb_set_size($this->handler, $width, $height);
	}
	public Function setStyle($style){
		return wb_set_style($this->handler, $style);
	}
	public Function setText($text){
		return wb_set_text($this->handler, $text);
	}
	public Function setVisible($visible){
		return wb_set_visible($this->handler, $visible);
	}
}
