<?php

//----------------------------------------------------------------- DEPENDNCIAS

include_once("../inc/winbinder.php");

//-------------------------------------------------------------------- FUNCTIONS

function process_1($window, $id)
{
	wb_destroy_window($window);
}

function get_struct_data($var, $type)	// Returns an associative array containing the structure field values
{
	return eval("return unpack(STRUCT_$type, wb_peek($var, STRUCT_$type" . "_SIZE));");
}

$win2 = wb_create_window(NULL, PopupWindow, "WinBinder", 120, 90);
wb_set_handler($win2, "process_1");

// Obtain the window handler and change the window class

$wbobj = get_struct_data($win2, "WBOBJ");	// Fill $pwbo with the contents of the C structure "WBOBJ"
echo "Window handler is '" . wb_peek($wbobj['handler']) . "'\n";
echo "Window class is " . $wbobj['wbclass']. "\n";
$wbobj['wbclass'] = 103;
echo "Window class is now {$wbobj['wbclass']}\n";

// The above works, but it's a bit awkward. I'd prefer to have something like:

/*
//SetWindowText = wb_declare_function("SetWindowTextA", "USER.DLL", "hwnd, string", "bool", Stdcall);

class WBOBJ {

//	var $wbobj;// = unpack(STRUCT_WBOBJ, $this);
//	var $handle;// = wbobj["handle"];
//	var $id;// = wbobj["id"];

//	function WBObject() {			// Ctor
//		$wbobj = unpack(STRUCT_WB, $this);
//		$this->handle = $wbobj["handle"];
//	}

	function WBOBJ($pwbo) {
//		$wbobj = unpack(STRUCT_WB, wb_get_address($pwbo));
		$wbobj = unpack(STRUCT_WBOBJ, wb_peek($pwbo, STRUCT_WBOBJ_SIZE));
		$this->id = $wbobj["id"];
	}
}

function process_1($window, $id) {}

class WBOBJ {	// Assigns each field value to a class member
	// Some magic here
}

$win2 = wb_create_window(NULL, PopupWindow, "WinBinder", 120, 90);
wb_set_handler($win2, "process_1");

// Obtain the window handler and change the window class

$pwbo = new WBOBJ;		// Fill $pwbo with the contents of the C structure "WBOBJ"
echo "Window class is " . $wbobj->handler . ".\n";
$wbobj->wbclass = 103;
echo "Window class is now {$wbobj->wbclass}.\n";
*/

function test_lowlevel($window)
{
	return;


	$result = "TEST LOW-LEVEL FUNCTIONS\n\n";
	$result .= "Momentarily not working!\n";

/*	// CODE IS BROKEN -- Rubem

	// With main window

	$result .= "Current window data:\n";
	$wbobj = unpack(STRUCT_WBOBJ, wb_peek($window, STRUCT_WBOBJ_SIZE));
	$result .= print_r($wbobj, true);
	$orig_address = wb_get_address($wbobj["handler"]);
	$orig_handler = wb_peek($wbobj["handler"]);
	$result .= "Name of current window handler: $orig_handler\n";

//	$result .= "Setting temp handle using wb_set_handler()...\n";
//	wb_set_handler($window, "dummy_callback");
//	$wbobj = unpack(STRUCT_WBOBJ, wb_peek($window, STRUCT_WBOBJ_SIZE));
//	$handler = wb_peek($wbobj["handler"]);
//	$result .= "New window handler is $handler\n";

	$result .= "Changing handle using wb_poke()...\n";
	$newname = "dummy_callback";
	wb_poke($window + 28, pack("V", wb_get_address($newname)), 4);
	$wbobj = unpack(STRUCT_WBOBJ, wb_peek($window, STRUCT_WBOBJ_SIZE));
	$handler = wb_peek($wbobj["handler"]);
	$result .= "Window handler is now $handler\n";
//	$result .= print_r($wbobj, true);

//	$result .= "Resetting handle using wb_poke()...\n";
//	$newname = "process_main";
//	wb_poke($window + 28, pack("V", wb_get_address($newname)), 4);
//	$wbobj = unpack(STRUCT_WBOBJ, wb_peek($window, STRUCT_WBOBJ_SIZE));
//	$handler = wb_peek($wbobj["handler"]);
//	$result .= "Window handler is now $handler\n";

//	wb_set_handler($window, "process_main");

	// O valor de $handler  wb_peek(wb_get_address($handler));
	// The offset of member 'pszCallBackFn' in struct WBOBJ is 28
//	$str .= wb_get_attrib($window, "handler") . "\n";
//	wb_set_handler($window, "process_main");
//	$str .= wb_get_attrib($window, "handler") . "\n";

	// With control

	$result .= "\nGetting control handle...\n\n";
	$ctrl = wb_get_control($window, $id);
	$wbobj = unpack(STRUCT_WBOBJ, wb_peek($ctrl, STRUCT_WBOBJ_SIZE));
	$result .= sprintf("Original current item # is %d\n", $wbobj["item"]);

	$result .= "\nChanging the value of member 'item'...\n";
	// The offset of member 'item' in struct WBOBJ is 12
	wb_poke($ctrl + 12, pack("V", 1200), 4);
	$wbobj = unpack(STRUCT_WBOBJ, wb_peek($ctrl, STRUCT_WBOBJ_SIZE));
	$result .= sprintf("Current item # is now %d\n", $wbobj["item"]);

	$result .= "\nGetting control handle again...\n\n";
	$ctrl = wb_get_control($window, $id);
	$wbobj = unpack(STRUCT_WBOBJ, wb_peek($ctrl, STRUCT_WBOBJ_SIZE));
	$result .= sprintf("Current item # is still %d\n", $wbobj["item"]);

	$result .= sprintf("\nTested items:\n%s\n%s\n%s\n",
		"wb_peek",
		"STRUCT_WBOBJ",
		"wb_poke"
	);
*/
	$result .= "\nEND TESTS\n\n";

	return $result;
}

// Dummy callback function

function dummy_callback($window)
{
	echo "k";
}

//-------------------------------------------------------------------------- FIM

?>